// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: Plant.proto
#ifdef _MSC_VER
#pragma warning(disable:4125)
#endif
#include "Plant.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/io/zero_copy_stream_impl_lite.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)

namespace dfproto {
class PlantDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<Plant>
      _instance;
} _Plant_default_instance_;
}  // namespace dfproto
namespace protobuf_Plant_2eproto {
static void InitDefaultsPlant() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::dfproto::_Plant_default_instance_;
    new (ptr) ::dfproto::Plant();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::dfproto::Plant::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<0> scc_info_Plant =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 0, InitDefaultsPlant}, {}};

void InitDefaults() {
  ::google::protobuf::internal::InitSCC(&scc_info_Plant.base);
}

}  // namespace protobuf_Plant_2eproto
namespace dfproto {

// ===================================================================

void Plant::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int Plant::kXFieldNumber;
const int Plant::kYFieldNumber;
const int Plant::kIsShrubFieldNumber;
const int Plant::kMaterialFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

Plant::Plant()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_Plant_2eproto::scc_info_Plant.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:dfproto.Plant)
}
Plant::Plant(const Plant& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&x_, &from.x_,
    static_cast<size_t>(reinterpret_cast<char*>(&material_) -
    reinterpret_cast<char*>(&x_)) + sizeof(material_));
  // @@protoc_insertion_point(copy_constructor:dfproto.Plant)
}

void Plant::SharedCtor() {
  ::memset(&x_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&material_) -
      reinterpret_cast<char*>(&x_)) + sizeof(material_));
}

Plant::~Plant() {
  // @@protoc_insertion_point(destructor:dfproto.Plant)
  SharedDtor();
}

void Plant::SharedDtor() {
}

void Plant::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const Plant& Plant::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_Plant_2eproto::scc_info_Plant.base);
  return *internal_default_instance();
}


void Plant::Clear() {
// @@protoc_insertion_point(message_clear_start:dfproto.Plant)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 15u) {
    ::memset(&x_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&material_) -
        reinterpret_cast<char*>(&x_)) + sizeof(material_));
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool Plant::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:dfproto.Plant)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required uint32 x = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          set_has_x();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required uint32 y = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          set_has_y();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required bool is_shrub = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {
          set_has_is_shrub();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &is_shrub_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional uint32 material = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(32u /* 32 & 0xFF */)) {
          set_has_material();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &material_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:dfproto.Plant)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:dfproto.Plant)
  return false;
#undef DO_
}

void Plant::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:dfproto.Plant)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // required uint32 x = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(1, this->x(), output);
  }

  // required uint32 y = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(2, this->y(), output);
  }

  // required bool is_shrub = 3;
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(3, this->is_shrub(), output);
  }

  // optional uint32 material = 4;
  if (cached_has_bits & 0x00000008u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(4, this->material(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:dfproto.Plant)
}

size_t Plant::RequiredFieldsByteSizeFallback() const {
// @@protoc_insertion_point(required_fields_byte_size_fallback_start:dfproto.Plant)
  size_t total_size = 0;

  if (has_x()) {
    // required uint32 x = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->x());
  }

  if (has_y()) {
    // required uint32 y = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->y());
  }

  if (has_is_shrub()) {
    // required bool is_shrub = 3;
    total_size += 1 + 1;
  }

  return total_size;
}
size_t Plant::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:dfproto.Plant)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  if (((_has_bits_[0] & 0x00000007) ^ 0x00000007) == 0) {  // All required fields are present.
    // required uint32 x = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->x());

    // required uint32 y = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->y());

    // required bool is_shrub = 3;
    total_size += 1 + 1;

  } else {
    total_size += RequiredFieldsByteSizeFallback();
  }
  // optional uint32 material = 4;
  if (has_material()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->material());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void Plant::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const Plant*>(&from));
}

void Plant::MergeFrom(const Plant& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:dfproto.Plant)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 15u) {
    if (cached_has_bits & 0x00000001u) {
      x_ = from.x_;
    }
    if (cached_has_bits & 0x00000002u) {
      y_ = from.y_;
    }
    if (cached_has_bits & 0x00000004u) {
      is_shrub_ = from.is_shrub_;
    }
    if (cached_has_bits & 0x00000008u) {
      material_ = from.material_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void Plant::CopyFrom(const Plant& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:dfproto.Plant)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool Plant::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000007) != 0x00000007) return false;
  return true;
}

void Plant::Swap(Plant* other) {
  if (other == this) return;
  InternalSwap(other);
}
void Plant::InternalSwap(Plant* other) {
  using std::swap;
  swap(x_, other->x_);
  swap(y_, other->y_);
  swap(is_shrub_, other->is_shrub_);
  swap(material_, other->material_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string Plant::GetTypeName() const {
  return "dfproto.Plant";
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace dfproto
namespace google {
namespace protobuf {
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::dfproto::Plant* Arena::CreateMaybeMessage< ::dfproto::Plant >(Arena* arena) {
  return Arena::CreateInternal< ::dfproto::Plant >(arena);
}
}  // namespace protobuf
}  // namespace google

// @@protoc_insertion_point(global_scope)
